import React from 'react';
import ReactDOM from 'react-dom';

//This script is packed with learning material. csv2json(csv) function at the top is worth continued exploring of use.
// but I got frustrated and just made the json string by hand below.
    console.clear()
    var jsonstring;
		var curstate;
		var curyear;
    function csv2json(csv){
      
      var nested = d3.nest()
      	.key(function(d) { return d.name;} )
      	.key(function(d) { return d.group;} )
      	.rollup(function(v) {})
        .entries(csv)
      	
      var json = nested.map(function(d){
        var namerecord = {};
        
        // this is the variable that we grouped by
        namerecord.name = d.key; 
        
//        namerecord.group = d.values[0].group;
        namerecord.group = d.values[0].group;
        
        // these are the time-series variables from the original script
        // use a "map" to grab the year and amount from each of the child "values"
        namerecord.amount1 = d.values.map(function(c){ return [c.year, c.amount1]; });
        namerecord.amount2 = d.values.map(function(c){ return [c.year, c.amount2]; });
        
        return namerecord;
      });
      
      return json;
    }

d3.csv("https://gist.githubusercontent.com/bootshine2/dc83fa6615ecf51fb382e233bf90840a/raw/b36dc061260662b23849d71599d12b336ce027c9/Bee%2520Colony%2520Loss4.csv").then (function(csv){
    
      csv.forEach(function(d) {
        d.Year = +d.Year;
        d.Loss = +d.Loss;
        d.Beekeepers = +d.Beekeepers;
        d.Colonies = +d.Colonies;
        if (jsonstring != null) {
          if (d.State == curstate) {
            if (d.Year == curyear) {
            	jsonstring += ',\n\t\t\t{"name": "Loss", "size": '+d.Loss+'},\n\t\t\t{"name": "Beekeepers", "size": '+d.Beekeepers+'},\n\t\t\t{"name": "Colonies", "size": '+d.Colonies+'}\n\t\t]}';
            }
            else {
              curyear = d.Year;
            	jsonstring += ',\n\t\t{"name": '+curyear+', "children": [\n\t\t\t{"name": "Loss", "size": '+d.Loss+'},\n\t\t\t{"name": "Beekeepers", "size": '+d.Beekeepers+'},\n\t\t\t{"name": "Colonies", "size": '+d.Colonies+'}\n\t\t]}';
            }
          }
          else {
            //I am presuming that if I'm here, there is a current record I have read. If State in the current record isn't the State from the previous record 
            // then update curstate, close out the previous state brackets in the json string, and add the state, year, and other headers and data into json here.
            curstate = d.State;
            curyear = d.Year;
            jsonstring += '\n\t]},\n\t{"name": "'+curstate+'", "children": [\n\t\t{"name": '+curyear+', "children": [\n\t\t\t{"name": "Loss", "size": '+d.Loss+'},\n\t\t\t{"name": "Beekeepers", "size": '+d.Beekeepers+'},\n\t\t\t{"name": "Colonies", "size": '+d.Colonies+'}\n\t\t]}';
          }
//	        jsonstring += "State: "+d.State+"; Year: "+d.Year+", Loss: "+d.Loss+", Beekeepers: "+d.Beekeepers+", Colonies: "+d.Colonies+"\n";
        }
        else { //I am assuming that my data has at least one row in it
          curstate = d.State;
          curyear = d.Year;
          jsonstring += '{"name": "flare", "children": [\n\t{"name": "'+curstate+'", "children": [\n\t\t{"name": '+curyear+', "children": [\n\t\t\t{"name": "Loss", "size": '+d.Loss+'},\n\t\t\t{"name": "Beekeepers", "size": '+d.Beekeepers+'},\n\t\t\t{"name": "Colonies", "size": '+d.Colonies+'}\n\t\t]}';
        }
      });
  		//don't forget to close out the string here.
  		jsonstring += '\n\t]}\n]}';
      console.log(jsonstring);         
      console.log(csv);
      
//      var json = csv2json(csv);     
//      console.log(json);
      
//      d3.select("p#json").html(JSON.stringify(json, null, 2));
      
      
    });



const App = () => (
  <div>Copy the console.log output for the json string for the <a href="https://gist.githubusercontent.com/bootshine2/dc83fa6615ecf51fb382e233bf90840a/raw/b36dc061260662b23849d71599d12b336ce027c9/Bee%2520Colony%2520Loss4.csv">bee colony loss data</a></div>
);

const rootElement = document.getElementById('root');
ReactDOM.render(<App />, rootElement);